<template>
  <div class="details px-32 py-8 h-screen">
    <NuxtLink to="/starlist" class="underline">
      Retour à la liste des astres
    </NuxtLink>
    <h1 class="font-mono text-3xl text-center mb-8">
      Détails sur {{ star.name }}
    </h1>
    <div>
      <table class="min-w-full">
        <thead class="bg-gray-800 text-white">
          <tr>
            <th class="w-1/3 text-left py-3 px-4 font-mono uppercase text-sm">
              Propriété
            </th>
            <th class="w-1/3 text-left py-3 px-4 font-mono uppercase text-sm">
              Valeur
            </th>
          </tr>
        </thead>
        <tbody class="text-white">
          <tr>
            <td class="w-1/3 text-left py-3 px-4 font-mono">Nom</td>
            <td class="w-1/3 text-left py-3 px-4 font-mono">{{ star.name }}</td>
          </tr>
          <tr>
            <td class="w-1/3 text-left py-3 px-4 font-mono">Nom (anglais)</td>
            <td class="w-1/3 text-left py-3 px-4 font-mono">
              {{ star.englishName }}
            </td>
          </tr>
          <tr>
            <td class="w-1/3 text-left py-3 px-4 font-mono">Planète</td>
            <td class="w-1/3 text-left py-3 px-4 font-mono">
              {{ star.isPlanet ? "Oui" : "Non" }}
            </td>
          </tr>
          <tr>
            <td class="w-1/3 text-left py-3 px-4 font-mono">
              Axe semis majeur
            </td>
            <td class="w-1/3 text-left py-3 px-4 font-mono">
              {{ star.semimajorAxis }}
            </td>
          </tr>
          <tr>
            <td class="w-1/3 text-left py-3 px-4 font-mono">Périhélie</td>
            <td class="w-1/3 text-left py-3 px-4 font-mono">
              {{ star.perihelion }}
            </td>
          </tr>
          <tr>
            <td class="w-1/3 text-left py-3 px-4 font-mono">Aphélion</td>
            <td class="w-1/3 text-left py-3 px-4 font-mono">
              {{ star.aphelion }}
            </td>
          </tr>
          <tr>
            <td class="w-1/3 text-left py-3 px-4 font-mono">Excentricité</td>
            <td class="w-1/3 text-left py-3 px-4 font-mono">
              {{ star.eccentricity }}
            </td>
          </tr>
          <tr>
            <td class="w-1/3 text-left py-3 px-4 font-mono">Inclinaison</td>
            <td class="w-1/3 text-left py-3 px-4 font-mono">
              {{ star.inclination }}
            </td>
          </tr>
          <tr>
            <td class="w-1/3 text-left py-3 px-4 font-mono">Densité</td>
            <td class="w-1/3 text-left py-3 px-4 font-mono">
              {{ star.density }}
            </td>
          </tr>
          <tr>
            <td class="w-1/3 text-left py-3 px-4 font-mono">Gravité</td>
            <td class="w-1/3 text-left py-3 px-4 font-mono">
              {{ star.gravity }}
            </td>
          </tr>
          <tr v-if="star.mass">
            <td class="w-1/3 text-left py-3 px-4 font-mono">Masse</td>
            <td class="w-1/3 text-left py-3 px-4 font-mono">
              {{ star.mass.massValue }} x10<sup>{{
                star.mass.massExponent
              }}</sup>
            </td>
          </tr>
          <tr v-if="star.aroundPlanet">
            <td class="w-1/3 text-left py-3 px-4 font-mono">
              Planète la plus proche
            </td>
            <td class="w-1/3 text-left py-3 px-4 font-mono underline">
              <nuxt-link :to="`/details/${star.aroundPlanet.planet}`">{{
                star.aroundPlanet.planet
              }}</nuxt-link>
            </td>
          </tr>
          <tr v-if="star.moons">
            <td class="w-1/3 text-left py-3 px-4 font-mono align-top">Lunes</td>
            <td class="w-1/3 text-left py-3 px-4 font-mono underline">
              <div v-for="(item, index) of star.moons" :key="index">
                <nuxt-link :to="getMoonRoute(item.moon)">{{
                  item.moon
                }}</nuxt-link>
                <br />
              </div>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
export default {
  // Récupère les données de l'API puis retourne l'élément qui match avec l'id passé dans l'URL.
  // Sinon renvoi vers la page d'erreur.
  async asyncData({ params, $http, error }) {
    try {
      const list = await $http.$get(
        `https://api.le-systeme-solaire.net/rest/bodies/`
      );
      const star = list.bodies.find((item) => item.id === params.id);
      return { star };
    } catch (err) {
      error(err);
    }
  },
  methods: {
    getMoonRoute(moon) {
      const star = this.$store.getters["getStars"].find(
        (item) => item.name === moon
      );
      return "/details/" + star.id;
    },
  },
};
</script>

<style>
.details {
  background-color: #3a256e;
  color: #fff;
  height: 100%;
}
</style>